Subject: Re: Notes on Using Git with Subprojects

From: Shawn Pearce <[email-masked]>
Date: Wed, 27 Sep 2006 23:52:38 -0400

A Large Angry SCM <[email-masked]> wrote:
> Jeff King wrote:
> [...]
> >One thing that I believe some people have requested for subprojects is
> >to avoid downloading files/history for subprojects you're not interested
> >in.  I think this could be faciliated in this scheme by only cloning the
> >heads of the subprojects you're interested in (there would need to be
> >special machinery to handle this at the root level if we want to allow
> >making root commits without necessarily having all of the subprojects).
> 
> In what I'm suggesting, commits are local to a project's working 
> directory repository and are pushed somewhere else to be recorded long 
> term. Since projects are stand alone, possibly with dependencies, 
> working on a (sub)project without having other associated (sub)projects 
> is accomplished by checking it out.
> 
> >A first step to this would be an argument to git-clone to allow cloning
> >only a subset of refs.
> 
> Something like this?
> 
> 	git-init-db
> 	git-fetch <repository> <refspecs>

More like:

 	git-init-db
 	git-fetch --keep <repository> <refspecs>

but yes.  :-)

-- 
Shawn.